#include <iostream>

// Prototyp des Algorithmus ersetzt durch Template
template <class Iterator, typename T> Iterator find(Iterator begin, Iterator end, const T& wert)
{
  while (begin != end                  // Zeigervergleich
         && *begin != wert) {          // Dereferenzierung und Objektvergleich
    ++begin;                           // nächste Stelle
  }
  return begin;
}

// neuer Typname IteratorType für `Zeiger auf const int'
using IteratorType = const int*;

int main()
{
  constexpr int ANZAHL{100};
  int einContainer[ANZAHL];                  // Container definieren
  IteratorType begin{einContainer};          // Zeiger auf den Anfang
  //  Position NACH dem letzten Element
  IteratorType end{einContainer + ANZAHL};

  // Container mit beliebigen Werten füllen (hier: gerade Zahlen)
  for (unsigned int i = 0; i < ANZAHL; ++i) {
    einContainer[i] = 2 * i;
  }

  int zahl{0};
  while (zahl != -1) {
    std::cout << " gesuchte Zahl eingeben (-1 = Ende):";
    std::cin >> zahl;
    if (zahl != -1) {          // weitermachen?
      IteratorType position = find(begin, end, zahl);
      if (position != end) {
        std::cout << "gefunden an Position " << (position - begin) << '\n';
      }
      else {
        std::cout << zahl << " nicht gefunden!\n";
      }
    }
  }
}
