#include <boost/asio.hpp>
#include <cstdlib>
#include <iostream>
using namespace std;

int main(int argc, char* argv[])
{
  if (argc != 3) {
    cout << "Gebrauch: " << argv[0] << " <IP-Adresse> <port>\n";
    return 1;
  }
  boost::asio::io_service ioService;
  unsigned short port = atoi(argv[2]);  // atoi() siehe Tabelle 33.6 auf  Seite 947
  boost::asio::ip::tcp::endpoint 
        server(boost::asio::ip::address::from_string(argv[1]), port);
  boost::asio::ip::tcp::socket socket(ioService);
  socket.connect(server);
  cout << "Lokaler Endpunkt:  " << socket.local_endpoint();
  cout << "\nVerbindung mit " << socket.remote_endpoint() << " hergestellt." 
       << endl;                      // damit die Nachricht vor dem Lesen erscheint
  constexpr int anzahl{80};
  char buf[anzahl + 1];
  // Es werden maximal anzahl Bytes gelesen:
  auto anzahlBytes = socket.read_some(boost::asio::buffer(buf, anzahl));
  buf[anzahlBytes] = '\0';                   // Rest für Ausgabe ignorieren
  cout << buf << '\n';
}

