#include <iostream>
using namespace std;

// Funktionen, auf die ein Zeiger gerichtet wird:
int min(int x, int y) { return y < x ? y : x; }
int max(int x, int y) { return y < x ? x : y; }
int main()
{
  int a {1700};
  int b {1000};
  int (*fp)(int, int){nullptr};             // fp ist Zeiger auf eine Funktion

  do {
    char c {'x'};
    cout << "max (1) oder min (0) ausgeben (andere Zahl = Ende) ?";
    cin >> c;

    // Zuweisung von max() oder min() (ohne Angabe von Klammern nach dem Funktionsnamen)
    switch (c) {
    case '0':
      fp = &::min;          // Funktionsadresse zuweisen
      break;
      // :: bedeutet: die obige globale Funktion nehmen.
      // Damit wird die Verwechslung mit der Standard-Funktion std::min() 
      // verhindert, falls später mal der Header <algorithm> eingebunden werden sollte.
      // Ohne den Adressoperator & wandelt der Compiler den
      // Funktionsnamen automatisch in die Adresse um:
    case '1':
      fp = ::max;
      break;
    default:
      fp = nullptr;
    }
    if (fp) {                               // d.h if (fp != nullptr)
      // Dereferenzierung des Funktionszeigers und Aufruf
      cout << (*fp)(a, b) << '\n';
      // oder auch direkte Verwendung des Namens (implizite Typumwandlung)
      cout << fp(a, b) << '\n';
    }
  } while (fp);
}


