#include <exception>
#include <iostream>
#include <stdexcept>
#include <string>
using namespace std;

struct MeineException : public runtime_error {  // Hilfsklasse
  MeineException(const string& meld)
    :  runtime_error(meld)
  {}
};
struct andererFehler {};                       // Hilfsklasse

void fehlersimulation(char c)
{
  try {
    switch(c) {                                 // break nicht notwendig
       case 'c' : throw "C-String geworfen";
       case 'e' : throw exception();
       case 'm' : throw MeineException("Fehler: MeineException");
       case 'x' : throw andererFehler();
    }
  }
  catch(const char* meldung) {
    cout << "Exception: " << meldung << '\n';
  }
  catch(const MeineException& me) {
    cout << "Exception: MeineException aufgefangen und weitergeleitet\n";
    throw;
  }
  catch(const exception& ex) {
    cout << "Exception: exception aufgefangen\n";
  }
  catch(...) {       // Ellipse ... für nicht bis hier aufgefangene Exceptions
    cout << "weitergeleitete Exception\n";
    throw;           // Weitergabe an höhere Instanz
  }
}

int main()
{
  try {
    char c;
    do  { 
      cout << "Simulation von Fehlern, die eine Exception auslösen.\n"
        "Auswahl für Exception-Parameter eingeben:\n"
        "c : const char*\n"
        "e : exception\n"
        "m : KLasse MeineException (an Aufrufer weitergeleitet)\n"
        "x : andererFehler2 (nicht behandelte Exception / Programmabbruch)\n"
        "sonst : neue Abfrage\n: ";
      cin >> c;
      fehlersimulation(c);
    } while(c != 'e' && c != 'c' && c != 'm');
  }
  catch(const MeineException& me) {
    cout << "MeineException in main() aufgefangen\nwhat() = "
         << me.what() << '\n';
  }
}

