#include <iostream>
#include <new>                          // set_new_handler() und bad_alloc

void speicherfehler()
{
  std::cerr << "Memory erschöpft! Eigener new_handler aufgerufen!\n";
  // andere mögliche Operationen weggelassen
  // Annahme: Beschaffung weiteren Speichers ist gescheitert.
  // Daher: Exception weiterreichen.
  throw std::bad_alloc();
}

int main()
{
  std::set_new_handler(speicherfehler);
  std::cout << "Anzahl zu reservierender Gigabytes: ";
  int anzahl{0};
  std::cin >> anzahl;
  try {
    char* speicher = new char[anzahl * 1'000'000'000L];
    std::cout << anzahl << " GB problemlos beschafft.\n";
    delete[] speicher;
  }
  catch (const std::bad_alloc& exc) {
    std::cerr << anzahl << " GB konnten nicht beschafft werden! " << exc.what() << '\n';
  }
}

