#ifndef B_H
#define B_H
#include "A.h"

class B : public A {
public:
  B(int a_, int b_)
      : A(a_),                              // Oberklassenkonstruktor
        b{b_}
  {                                         // ggf. lokale Daten
  }

  B(const B&) = delete;
  B& operator=(const B&) = delete;
  B(B&&) = delete;
  B& operator=(B&&) = delete;

  virtual std::unique_ptr<A> clone() const override
  {
    std::cout << "virtual B* B::clone()\n";
    return std::unique_ptr<A>(new B(A::get(), b));
  }

  virtual void ausgabe() const override
  {
    A::ausgabe();
    std::cout << "B.b = " << b << ' ';
  }

protected:
  auto get() const { return b; }
  virtual bool isEqual(const A& arg) const override
  {
    std::cout << "B::isEqual(const A& arg)\n";
    return A::isEqual(arg) && b == static_cast<const B&>(arg).b;
  }

private:
  int b;
};
#endif
