#include "datumeingabeoperator.h"

// Einleseoperator für ein Datum. Erlaubte Formate: Tag.Monat.Jahr oder Tag/Monat/Jahr
std::istream& operator>>(std::istream& eingabe, Datum& d)
{
  char c{'\0'};
  int tag{0};
  int monat{0};
  int jahr{0};
  eingabe >> tag >> c;                           // Tag und 1. Trennzeichen
  if (c != '.' && c != '/') {
    eingabe.setstate(std::ios::failbit);         // Status setzen
  }
  else {
    eingabe >> monat >> c;                       // Monat und 2. Trennzeichen
    if (c != '.' && c != '/') {
      eingabe.setstate(std::ios::failbit);       // Status setzen
    }
    else {
      eingabe >> jahr;
    }
    if (istGueltigesDatum(tag, monat, jahr)) {   // nur dann ändern
      d.set(tag, monat, jahr);
    }
    else {
      eingabe.setstate(std::ios::failbit);
    }
  }
  if (!eingabe.good()) {
    throw UngueltigesDatumException(tag, monat, jahr);
  }
  return eingabe;
}
