#include <format>
#include <iostream>
enum class Farbe { rot, gruen, blau };          // hier: Abbildung auf 0, 1, 2
std::string_view Farbnamen[] = { "Rot", "Grün", "Blau" };
using namespace std;

template<>
struct fmt::formatter<Farbe> : fmt::formatter<string_view> {
  auto format(Farbe farbe, format_context& ctx) {
    int index = static_cast<int>(farbe);
    return formatter<string_view>::format(Farbnamen[index], ctx);
  }
};

int main()
{
  cout << fmt::format("{:.>8} {:0>8} {:.>8}\n", Farbe::rot, 44, Farbe::blau);
}
